//================================================================================
// DeemerLaunchMsg
//================================================================================
class DeemerLaunchMsg extends LocalMessagePlus;

//#exec AUDIO IMPORT FILE="Sounds\NuclearLaunchF.WAV" NAME="NuclearLaunchF"
#exec AUDIO IMPORT FILE="Sounds\NuclearLaunchM.WAV" NAME="NuclearLaunchM" Group="Snd"

var sound FLaunchDeemerSound;
var sound MLaunchDeemerSound;

static function float GetOffset (int Switch, float YL, float ClipY)
{
	return (Default.YPos / 768.00) * ClipY - 2 * YL;
}

static function string GetString (optional int Switch, optional PlayerReplicationInfo RelatedPRI_1, optional PlayerReplicationInfo RelatedPRI_2, optional Object OptionalObject)
{
    return "Warning, Redeemer Launched !";
}

static simulated function ClientReceive (PlayerPawn P, optional int Switch, optional PlayerReplicationInfo RelatedPRI_1, optional PlayerReplicationInfo RelatedPRI_2, optional Object OptionalObject)
{
	Super.ClientReceive(P,Switch,RelatedPRI_1,RelatedPRI_2,OptionalObject);
	P.ClientPlaySound(Default.MLaunchDeemerSound,,True);
	return;
}

defaultproperties
{
     MLaunchDeemerSound=Sound'MH2_NS_V2.Snd.NuclearLaunchM'
     FontSize=2
     bIsSpecial=True
     bIsUnique=True
     bFadeMessage=True
     DrawColor=(R=100,G=250,B=100)
     YPos=196.000000
     bCenter=True
}
