//=============================================================================
// Mercenary - a kind of... 
// Class ghosted for replacement, solved by Base
//=============================================================================
class ExMercenary extends Mercenary;

// FIXME - also have sound breathmr
// FIX YOURSELF !

//======================================================================
// Mercenary Functions
// To mention your Super.PrebeginPlay() ???

event FootZoneChange(ZoneInfo newFootZone)
{
	local float OldPainTime;

	OldPainTime = PainTime;
	Super(ScriptedPawn).FootZoneChange(newFootZone);
	if ( bIsInvulnerable && (PainTime <= 0) )
	{
		PainTime = FMax(OldPainTime, 0.1);
		BecomeNormal(); //No longer shit
	}
	//Here is indeed interesting how you become GOD, but you are just a loser
} 

event HeadZoneChange(ZoneInfo newHeadZone)
{
	local float OldPainTime;

	OldPainTime = PainTime;
	Super(ScriptedPawn).HeadZoneChange(newHeadZone);
	if ( bIsInvulnerable && (PainTime <= 0) )
	{
		PainTime = FMax(OldPainTime, 0.1);
		BecomeNormal();
	}
}

function PainTimer()
{
	if ( Health <= 0 )
		return;
	if ( !bIsInvulnerable )
	{
//??????????????????????????
		if ( bHasInvulnerableShield && Region.Zone.bPainZone && (Region.Zone.DamagePerSec > 0)
		&& !Region.Zone.bWaterZone) //Monkey won't bug with manure in a few cases
			BecomeInvulnerable();
// I'm interested about lavas
//??????????????????????????
		Super(ScriptedPawn).PainTimer(); //Go, move far away
		if ( bIsInvulnerable )
			PainTime = 1.0;
		return;
	}
	InvulnerableCharge -= 1.0;
	if ( (InvulnerableCharge < 0) || (Level.TimeSeconds - InvulnerableTime > 4 + 5 * FRand()) )
		BecomeNormal();
	else
		PainTime = 1.0;
}

function PlayHeadDeath(name DamageType)
{
	local carcass carc;

	if ( ((DamageType == 'Decapitated') || ((Health < -20) && (FRand() < 0.5)))
		 && !Level.Game.bVeryLowGore )
	{
		carc = Spawn(class 'ExCreatureChunks',,, Location + CollisionHeight * vect(0,0,0.8), Rotation + rot(3000,0,16384) );
		//doh - something better - I guess... 
		if (carc != None)
		{
			carc.Mesh = mesh'MercHead';
			carc.Initfor(self);
			carc.Velocity = Velocity + VSize(Velocity) * VRand();
			carc.Velocity.Z = FMax(carc.Velocity.Z, Velocity.Z);
		}
		PlayAnim('Dead5',0.7,0.1);
		SprayOffset = 0;
	}
	else
		PlayAnim('Death',0.7,0.1);
	PlaySound(Die, SLOT_Talk, 4 * TransientSoundVolume);
}
/*
// To speak about, probably later
function PlayVictoryDance()
{
	//if ( FRand() < 0.5 )
	//{
		PlaySound(Flip, SLOT_Interact);
		PlayAnim('Jump', 1.0, 0.1);
	//}
	//else
	//	PlayAnim('BigDance', 0.7, 0.25);
}
*/

function bool CanFireAtEnemy()
{
	local vector HitLocation, HitNormal,X,Y,Z, projStart, EnemyDir, EnemyUp;
	local actor HitActor;
	local float EnemyDist;

	if ( Enemy == None || Enemy.bDeleteMe || Enemy.Health <= 0 ) //added
		return false;	//Is possible this one, right ?

	EnemyDir = Enemy.Location - Location;
	EnemyDist = VSize(EnemyDir);
	EnemyUp = Enemy.CollisionHeight * vect(0,0,0.9);
	if ( EnemyDist > 300 )
	{
		EnemyDir = 300 * EnemyDir/EnemyDist;
		EnemyUp = 300 * EnemyUp/EnemyDist;
	}
	
	GetAxes(Rotation,X,Y,Z);
	projStart = Location + 0.9 * CollisionRadius * X - 0.6 * CollisionRadius * Y;
	HitActor = Trace(HitLocation, HitNormal, projStart + EnemyDir + EnemyUp, projStart, true);

	if ( (HitActor == None) || (HitActor == Enemy) 
		|| ((Pawn(HitActor) != None) && (AttitudeTo(Pawn(HitActor)) <= ATTITUDE_Ignore)) )
		return true;

	HitActor = Trace(HitLocation, HitNormal, projStart + EnemyDir, projStart , true);

	return ( (HitActor == None) || (HitActor == Enemy) 
			|| ((Pawn(HitActor) != None) && (AttitudeTo(Pawn(HitActor)) <= ATTITUDE_Ignore)) );
}

function SprayTarget() //No sure how much target is damaged probably is a fake attack, dumb with other words
{
	if ( Target != None && ( !Target.bDeleteMe || ( Target.bIsPawn && Pawn(Target).Health > 0 ) ) )
		Super.SprayTarget();
}

/*
function SprayTarget()
{
	local vector EndTrace, fireDir;
	local vector HitNormal, HitLocation;
	local actor HitActor;
	local rotator AdjRot;
	local vector X,Y,Z;

	if ( Target != None && !Target.bDeleteMe )
	{
		AdjRot = Rotation;
		if ( AnimSequence == 'Dead5' )
			AdjRot.Yaw += 3000 * (2 - sprayOffset);
		else
			AdjRot.Yaw += 1000 * (3 - sprayOffset);
		sprayoffset++;
		fireDir = vector(AdjRot);
		if ( (sprayoffset == 1) || (sprayoffset == 3) || (sprayoffset == 5) )
		{
			GetAxes(Rotation,X,Y,Z);
			if ( AnimSequence == 'Spray' )
				spawn(class'MercFlare', self, '', Location + 1.25 * CollisionRadius * X - CollisionRadius * (0.2 * sprayoffset - 0.3) * Y);
			else
				spawn(class'MercFlare', self, '', Location + 1.25 * CollisionRadius * X - CollisionRadius * (0.1 * sprayoffset - 0.1) * Y);
		}
		if ( AnimSequence == 'Dead5' )
			sprayoffset++;
		EndTrace = Location + 2000 * fireDir;
		EndTrace.Z = Target.Location.Z + Target.CollisionHeight * 0.6;
		HitActor = TraceShot(HitLocation,HitNormal,EndTrace,Location);
		if ( HitActor != None ) //added - Need it ? Nope.
		{
			if ( HitActor == Level )   // Hit a wall
			{
				spawn(class'SmallSpark2',,,HitLocation+HitNormal*5,rotator(HitNormal*2+VRand()));
				spawn(class'SpriteSmokePuff',,,HitLocation+HitNormal*9);		
			}
			else if ( HitActor != self && HitActor != Owner )
			{
				HitActor.TakeDamage(10, self, HitLocation, 10000.0*fireDir, 'shot');			
				spawn(class'SpriteSmokePuff',,,HitLocation+HitNormal*9);		
			}
		}
	}
}
*/

function HitDamageTarget()
{
	if (Target == None || Target.bDeleteMe || (Target.IsA('Pawn') && Pawn(Target).Health <= 0) )
		goto NoCrapTarget;
	else
	{
		if (MeleeDamageTarget(PunchDamage, (PunchDamage * 1000 * Normal(Target.Location - Location))))
			PlaySound(PunchHit, SLOT_Interact);
	}
NoCrapTarget:
}

function PlayRangedAttack()
{
	//FIXME - if going to ranged attack need to
	//	TweenAnim('StillFire', 0.2);
	//What I need is a tween into time for the PlayAnim()
	//Probably you need an ass - YEAH, sure :|

	if ( Target == None || Target.bDeleteMe || ( Target.IsA('Pawn') && Pawn(Target).Health <= 0) ) //added
		goto NoStupidRanged;

	if ( bIsInvulnerable && !bCanFireWhileInvulnerable )
	{
		if ( Level.TimeSeconds - InvulnerableTime > 3 )
			BecomeNormal();	
		else if ( FRand() < 0.75 )
		{
			PlayChallenge();
			return;
		}
	}
	if (Region.Zone.bWaterZone)
	{
		PlayAnim('SwimFire');
		return;
	}
	MakeNoise(1.0);
	if (FRand() < 0.35)
	{
		PlayAnim('Shoot');
		SpawnRocket();
	}
	else
	{
		sprayoffset = 0;
		PlaySound(WeaponSpray, SLOT_Interact);
		PlayAnim('Spray');
	}
NoStupidRanged:
}

defaultproperties
{
     PunchDamage=20
     bHasInvulnerableShield=False
     Punch=Sound'UnrealI.Mercenary.swat1mr'
     PunchHit=Sound'UnrealI.Mercenary.hit1mr'
     Flip=Sound'UnrealI.Mercenary.flip1mr'
     CheckWeapon=Sound'UnrealI.Mercenary.weapon1mr'
     WeaponSpray=Sound'UnrealI.Mercenary.spray1mr'
     syllable1=Sound'UnrealI.Mercenary.syl1mr'
     syllable2=Sound'UnrealI.Mercenary.syl2mr'
     syllable3=Sound'UnrealI.Mercenary.syl3mr'
     syllable4=Sound'UnrealI.Mercenary.syl4mr'
     syllable5=Sound'UnrealI.Mercenary.syl5mr'
     syllable6=Sound'UnrealI.Mercenary.syl6mr'
     Footstep1=Sound'UnrealI.Mercenary.walk2mr'
     invulnerableCharge=9.000000
     CarcassType=Class'UnrealI.MercCarcass'
     Skill=2.000000
     Aggressiveness=0.500000
     RefireRate=0.500000
     bHasRangedAttack=True
     bMovingRangedAttack=True
     bGreenBlood=True
     RangedProjectile=Class'UnrealI.MercRocket'
     Acquire=Sound'UnrealI.Mercenary.chlng2mr'
     Fear=Sound'UnrealI.Mercenary.chlng3mr'
     Roam=Sound'UnrealI.Mercenary.nearbymr'
     Threaten=Sound'UnrealI.Mercenary.chlng3mr'
     bCanStrafe=True
     MeleeRange=50.000000
     GroundSpeed=280.000000
     AirSpeed=300.000000
     AccelRate=800.000000
     Health=180
     UnderWaterTime=-1.000000
     Intelligence=BRAINS_HUMAN
     HitSound1=Sound'UnrealI.Mercenary.injur2mr'
     HitSound2=Sound'UnrealI.Mercenary.injur3mr'
     Land=Sound'UnrealI.Mercenary.land1mr'
     Die=Sound'UnrealI.Mercenary.death1mr'
     CombatStyle=0.500000
     AmbientSound=Sound'UnrealI.Mercenary.amb1mr'
     DrawType=DT_Mesh
     Texture=Texture'UnrealI.Skins.Silver'
     Mesh=LodMesh'UnrealI.Merc'
     CollisionRadius=35.000000
     CollisionHeight=48.000000
     LightEffect=LE_NonIncidence
     LightBrightness=255
     LightHue=170
     LightSaturation=96
     LightRadius=12
     Mass=150.000000
     Buoyancy=150.000000
     RotationRate=(Pitch=3072,Yaw=65000,Roll=0)
     MenuName="Mercenary"
     NameArticle=" a "
     bCollideActors=False
     bBlockActors=False
     bBlockPlayers=False
}
