//=============================================================================
// Spawnpoint. MH specific fixes. This one will successfully replace older.
// Used by Creature Factories for spawning monsters
// Will use some tweaking here
//=============================================================================
class SpawnPoint expands UnrealShare.SpawnPoint;

var ThingFactory factory;

//Add-on for a better world
event PostBeginPlay()
{
	SetTimer(0.2,False);
	Super.PostBeginPlay();
}

singular event Timer()
{
	local ThingFactory Tf;

	bGameRelevant = False;
	foreach AllActors ( class 'ThingFactory', Tf, Tag )
	{
		if ( Tf != None )
		{
			factory = Tf;
//			log ( Self$ " found mother factory "$factory );
			break;
		}
	}
//	log ( Self$" declare as factory "$factory );

}

function bool Create()
{
	local pawn newcreature;
	local CreatureFactory pawnFactory;
	local pawn creature;
	local actor temp, A;
	local rotator newRot;

/*
#1 - No longer bullshitting because Win servers aren't cute with so much retarded craps
	if ( factory.bCovert && PlayerCanSeeMe() ) //make sure no player can see this
		return false;							//I'm sure about some stupidity of UTPG v451 and b too
// reminder to work around something named PlayerWatchingMe() or such...
*/

//#2 - We have to wrap here some troubles
	if ( Factory != None && Factory.prototype != None )
		temp = Spawn(factory.prototype);
//	log (Self$ " presumes prototype "$factory.prototype);
	if (temp == None)
		return false;
	newRot = rot(0,0,0);
	newRot.yaw = rotation.yaw;
	temp.SetRotation(newRot);
	temp.event = factory.tag;

//#3 - A pawn killed should not trigger other pawns from the same class and neither itself, you IDIOT, because it simply dies!
	if ( factory.itemtag != factory.tag ) //Loser ! You know what you did, right ? No, you don't...
		temp.tag = factory.itemtag;

	newcreature = pawn(temp);
//	log (Self$ " presumes creature "$newcreature);
	if( Event != '' )
		foreach AllActors( class 'Actor', A, Event )
			A.Trigger( Self, Instigator );
	if ( factory.bFalling ) //Surprise me at pupae. Timing not works. I won't fix it.
		temp.SetPhysics(PHYS_Falling);
	if (newcreature == None)
		return true;
	pawnFactory = CreatureFactory(factory);
	if (pawnFactory == None) //Still wonder WTF is wrong with you
	{
//#4 - No useless and stupid spam
//		log("Error - use creature factory to spawn pawns"); //?????????????
		return true;
	}
	if (ScriptedPawn(newcreature) != None )
	{
		ScriptedPawn(newcreature).Orders = pawnFactory.Orders;
		ScriptedPawn(newcreature).OrderTag = pawnFactory.OrderTag;
		ScriptedPawn(newcreature).Alarmtag = pawnFactory.AlarmTag;
//#5 - Changed according to original SetEnemy's dumbness vs Bot Support
		ScriptedPawn(newcreature).Enemy = pawnFactory.enemy;
		ScriptedPawn(newcreature).Hated = pawnFactory.enemy;
		ScriptedPawn(newcreature).GotoState('Attacking');
// SetPawnDifficulty could be called in here, eh... We have more options than a shit decal check
// Yep, shit because it was too small for Big Monsters anyway
// End of change
	}
	else 
		newcreature.enemy = pawnFactory.enemy;
	if (newcreature.enemy != None)
	{
		newcreature.lastseenpos = newcreature.enemy.location;
	}
	newcreature.SetMovementPhysics();
	if ( newcreature.Physics == PHYS_Walking)
		newcreature.SetPhysics(PHYS_Falling);
	return true;
}

defaultproperties
{
     bDirectional=True
     Texture=Texture'UnrealShare.S_SpawnP'
     SoundVolume=128
     bStatic=False
     bNoDelete=False
     bGameRelevant=True
}
